/** Copyright (C) 2017 by Bundesanstalt für Gewässerkunde
 * Software engineering by
 *  Björnsen Beratende Ingenieure GmbH
 *  Dr. Schumacher Ingenieurbüro für Wasser und Umwelt
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */
package test.sinfo;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.dive4elements.artifacts.httpclient.exceptions.ConnectionException;
import org.dive4elements.river.client.shared.exceptions.ServerException;

import test.AbstractBerechnungsartenTester.River;
import test.AbstractModuleRunner;
import test.ICalcMode;
import test.SimpleRecommendation;

/**
 * @author Domenico Nardi Tironi
 *
 */
final class SinfoFlowdepthMinMaxRunner extends AbstractModuleRunner {

    private final List<String> pairIds = new ArrayList<String>();

    public SinfoFlowdepthMinMaxRunner(final ICalcMode sinfoCalcFlowDepthMinmax, final double from, final double to, final River beispielfluss)
            throws ConnectionException, ServerException {
        super(AbstractModuleRunner.Infotype.sinfo, sinfoCalcFlowDepthMinmax, from, to, beispielfluss);
    }

    public void addRecommendationPair(final SimpleRecommendation rec1, final SimpleRecommendation rec2) throws ConnectionException, ServerException {
        this.pairIds.add(super.getRecommendationPairString(rec1, rec2));
    }

    @Override
    public void runTest() throws ServerException, IOException {

        /* Select River */
        super.selectRiver();

        /* Select calcmode */
        super.selectCalcMode();

        /* Select Range */
        super.selectRange();

        /* Select Fixpunkte */
        feedAndGo(extractPairData(this.pairIds, "diffids"), 0);

        // Describe collection
        describeCollection(); // wichtig, damit die Facets erzeugt werden

        // /* Export calculation */
        super.runTests();
    }
}
